# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/network/dns_resolver/cares/v3/cares_dns_resolver.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("CaresDnsResolverConfig",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.2.4")


@dataclass(eq=False, repr=False)
class CaresDnsResolverConfig(betterproto2.Message):
    """
    [#protodoc-title: c-ares DNS resolver]
    [#extension: envoy.network.dns_resolver.cares]

    Configuration for c-ares DNS resolver.
    [#next-free-field: 6]
    """

    resolvers: "list[_____config__core__v3__.Address]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    A list of dns resolver addresses.
    :ref:`use_resolvers_as_fallback<envoy_v3_api_field_extensions.network.dns_resolver.cares.v3.CaresDnsResolverConfig.use_resolvers_as_fallback>`
    below dictates if the DNS client should override system defaults or only use the provided
    resolvers if the system defaults are not available, i.e., as a fallback.
    """

    use_resolvers_as_fallback: "bool" = betterproto2.field(3, betterproto2.TYPE_BOOL)
    """
    If true use the resolvers listed in the
    :ref:`resolvers<envoy_v3_api_field_extensions.network.dns_resolver.cares.v3.CaresDnsResolverConfig.resolvers>`
    field only if c-ares is unable to obtain a
    nameserver from the system (e.g., /etc/resolv.conf).
    Otherwise, the resolvers listed in the resolvers list will override the default system
    resolvers. Defaults to false.
    """

    filter_unroutable_families: "bool" = betterproto2.field(4, betterproto2.TYPE_BOOL)
    """
    The resolver will query available network interfaces and determine if there are no available
    interfaces for a given IP family. It will then filter these addresses from the results it
    presents. e.g., if there are no available IPv4 network interfaces, the resolver will not
    provide IPv4 addresses.
    """

    dns_resolver_options: "_____config__core__v3__.DnsResolverOptions | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration of DNS resolver option flags which control the behavior of the DNS resolver.
    """

    udp_max_queries: "int | None | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, wraps=betterproto2.TYPE_UINT32, optional=True
    )
    """
    This option allows for number of UDP based DNS queries to be capped. Note, this
    is only applicable to c-ares DNS resolver currently.
    """


default_message_pool.register_message(
    "envoy.extensions.network.dns_resolver.cares.v3",
    "CaresDnsResolverConfig",
    CaresDnsResolverConfig,
)


from ......config.core import v3 as _____config__core__v3__
