# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/service/metrics/v2/metrics_service.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "StreamMetricsMessage",
    "StreamMetricsMessageIdentifier",
    "StreamMetricsResponse",
    "MetricsServiceStub",
    "MetricsServiceBase",
)

from collections.abc import AsyncIterable, AsyncIterator, Iterable
from dataclasses import dataclass
from typing import TYPE_CHECKING

import betterproto2
import grpclib
from betterproto2.grpc.grpclib_server import ServiceBase

from .....message_pool import default_message_pool

if TYPE_CHECKING:
    import grpclib.server
    from betterproto2.grpc.grpclib_client import MetadataLike
    from grpclib.metadata import Deadline

betterproto2.check_compiler_version("0.2.4")


@dataclass(eq=False, repr=False)
class StreamMetricsMessage(betterproto2.Message):
    identifier: "StreamMetricsMessageIdentifier | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Identifier data effectively is a structured metadata. As a performance optimization this will
    only be sent in the first message on the stream.
    """

    envoy_metrics: "list[____io__prometheus__client__.MetricFamily]" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    A list of metric entries
    """


default_message_pool.register_message(
    "envoy.service.metrics.v2", "StreamMetricsMessage", StreamMetricsMessage
)


@dataclass(eq=False, repr=False)
class StreamMetricsMessageIdentifier(betterproto2.Message):
    node: "___api__v2__core__.Node | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The node sending metrics over the stream.
    """


default_message_pool.register_message(
    "envoy.service.metrics.v2",
    "StreamMetricsMessage.Identifier",
    StreamMetricsMessageIdentifier,
)


@dataclass(eq=False, repr=False)
class StreamMetricsResponse(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.service.metrics.v2", "StreamMetricsResponse", StreamMetricsResponse
)


class MetricsServiceStub(betterproto2.ServiceStub):
    """
    [#protodoc-title: Metrics service]

    Service for streaming metrics to server that consumes the metrics data. It uses Prometheus metric
    data model as a standard to represent metrics information.
    """

    async def stream_metrics(
        self,
        messages: "AsyncIterable[StreamMetricsMessage] | Iterable[StreamMetricsMessage]",
        *,
        timeout: "float | None" = None,
        deadline: "Deadline | None" = None,
        metadata: "MetadataLike | None" = None,
    ) -> "StreamMetricsResponse":
        """
        Envoy will connect and send StreamMetricsMessage messages forever. It does not expect any
        response to be sent as nothing would be done in the case of failure.
        """

        return await self._stream_unary(
            "/envoy.service.metrics.v2.MetricsService/StreamMetrics",
            messages,
            StreamMetricsMessage,
            StreamMetricsResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


from .....io.prometheus import client as ____io__prometheus__client__
from ....api.v2 import core as ___api__v2__core__


class MetricsServiceBase(ServiceBase):
    """
    [#protodoc-title: Metrics service]

    Service for streaming metrics to server that consumes the metrics data. It uses Prometheus metric
    data model as a standard to represent metrics information.
    """

    async def stream_metrics(
        self, messages: "AsyncIterator[StreamMetricsMessage]"
    ) -> "StreamMetricsResponse":
        """
        Envoy will connect and send StreamMetricsMessage messages forever. It does not expect any
        response to be sent as nothing would be done in the case of failure.
        """

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_stream_metrics(
        self,
        stream: "grpclib.server.Stream[StreamMetricsMessage, StreamMetricsResponse]",
    ) -> None:
        request = stream.__aiter__()
        response = await self.stream_metrics(request)
        await stream.send_message(response)

    def __mapping__(self) -> "dict[str, grpclib.const.Handler":
        return {
            "/envoy.service.metrics.v2.MetricsService/StreamMetrics": grpclib.const.Handler(
                self.__rpc_stream_metrics,
                grpclib.const.Cardinality.STREAM_UNARY,
                StreamMetricsMessage,
                StreamMetricsResponse,
            ),
        }
